/*******************************************************************************
* File Name: ADDR.h  
* Version 1.90
*
* Description:
*  This file containts Status Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_STATUS_REG_ADDR_H) /* CY_STATUS_REG_ADDR_H */
#define CY_STATUS_REG_ADDR_H

#include "cytypes.h"
#include "CyLib.h"

    
/***************************************
*     Data Struct Definitions
***************************************/

/* Sleep Mode API Support */
typedef struct
{
    uint8 statusState;

} ADDR_BACKUP_STRUCT;


/***************************************
*        Function Prototypes
***************************************/

uint8 ADDR_Read(void) ;
void ADDR_InterruptEnable(void) ;
void ADDR_InterruptDisable(void) ;
void ADDR_WriteMask(uint8 mask) ;
uint8 ADDR_ReadMask(void) ;


/***************************************
*           API Constants
***************************************/

#define ADDR_STATUS_INTR_ENBL    0x10u


/***************************************
*         Parameter Constants
***************************************/

/* Status Register Inputs */
#define ADDR_INPUTS              4


/***************************************
*             Registers
***************************************/

/* Status Register */
#define ADDR_Status             (* (reg8 *) ADDR_sts_sts_reg__STATUS_REG )
#define ADDR_Status_PTR         (  (reg8 *) ADDR_sts_sts_reg__STATUS_REG )
#define ADDR_Status_Mask        (* (reg8 *) ADDR_sts_sts_reg__MASK_REG )
#define ADDR_Status_Aux_Ctrl    (* (reg8 *) ADDR_sts_sts_reg__STATUS_AUX_CTL_REG )

#endif /* End CY_STATUS_REG_ADDR_H */


/* [] END OF FILE */
