/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

volatile uint8 Reg[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
volatile uint16 Baud[15] = {20000,5000,2500,1250,625,312,156,104,52,26,625,625,625,625,625};
volatile uint8 DataIn;
volatile uint8 Addr = 16;

void DMA_init(volatile uint8*, volatile uint8*, volatile uint8*);
void shutDown();
void startUp();
void psocChanges();
void extChanges();

volatile uint8 UART_1_Send;

CY_ISR ( ResetISRAddr )
{
    memset((void*)Reg, 0, sizeof(Reg));
    shutDown();
    startUp();
}

int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
   
    DMA_init(Reg, &Addr, &DataIn);
   
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    ResetISR_StartEx( ResetISRAddr );
   
    startUp();
  
    for(;;)
    {
        /* Place your application code here. */
        psocChanges();
        if(Addr != 16)
        {
            extChanges();
        }
    }
}   

void shutDown()
{
    // UART_1 ShutDown
    UART_1_Stop();
    UART_1_Clock_Stop();
}

void startUp()
{   
    // 8000 Communication Startup
    INTR_Write(1);
    
    // Reset UART_1 variables
    UART_1_ReadTxStatus();
    UART_1_ClearRxBuffer();
    UART_1_Send = 1; 
}

void extChanges()
{
    Reg[Addr] = DataIn;
    switch(Addr & 0x0F)
    {
        case 0:
            if((Reg[0] & 0x0F) != 0)                             // Turn UART_1 On
            {
                UART_1_Clock_Start();
                UART_1_Clock_SetDividerValue(Baud[(Reg[0] & 0x0F) - 1]);
                       
                UART_1_Send = 0;

                UART_1_Start();
            }
            else                                                 // Turn UART_1 Off
            {
                UART_1_Stop();
                       
                UART_1_Send = 1;
                                  
                UART_1_Clock_Stop();
            }
            break;
        case 1:
            if(UART_1_Send == 0)                                     // Send a byte through UART_1
            {
                UART_1_Send = 1;
                UART_1_PutChar(Reg[1]);
            }
            break;
        case 2:
            break;
        case 3:
            break;
        case 4:
            break;
        case 5:
            break;
        case 6:
            break;
        case 7:
            break;
        case 8:
            break;
        case 9:
            break;
        case 10:
            break;
        case 11:
            break;
        case 12:
            break;
        case 13:
            break;
        case 14:
            break;
        case 15:
            break;
    }
    Addr = 16;
}

void psocChanges()
{
    // UART_1 Changes
    if(UART_1_GetRxBufferSize() == 1)                                // This code runs if UART_1 received a byte
    {
        Reg[2] = UART_1_ReadRxData();
        Reg[0] = Reg[0] | 0x40;
        if((Reg[0] & 0x10) == 0x10) {INTR_Write(0);}
    }
    
    if(UART_1_ReadTxStatus() & UART_1_TX_STS_COMPLETE)               // This code runs if UART_1 finishes transmitting a byte
    {
        Reg[0] = Reg[0] | 0x80;
        if((Reg[0] & 0x20) == 0x20) {INTR_Write(0);}
       
        UART_1_Send = 0;
    }
    if((Reg[0] & 0xC0) == 0) {INTR_Write(1);}                        // This code determines if we clear a UART_1 interrupt using the RF or TF flag
}
/* [] END OF FILE */